summaryrefslogtreecommitdiffstats
path: root/tests/common
diff options
context:
space:
mode:
authorMohamed Ashiq Liyazudeen <mliyazud@redhat.com>2017-05-08 21:08:09 +0530
committerMohamed Ashiq Liyazudeen <mliyazud@redhat.com>2017-05-08 22:39:07 +0530
commitec2d37cd987c6aafc7d0d71ab6c2643487d8ef92 (patch)
tree9d6137f38a97b149c4ef75878745ddd26095e2b2 /tests/common
parente63a97ed1b464975c9df07ea07dec3b136fa034a (diff)
downloadgluster-ec2d37cd987c6aafc7d0d71ab6c2643487d8ef92.tar.gz
gluster-ec2d37cd987c6aafc7d0d71ab6c2643487d8ef92.tar.bz2
gluster-ec2d37cd987c6aafc7d0d71ab6c2643487d8ef92.tar.xz
gluster-ec2d37cd987c6aafc7d0d71ab6c2643487d8ef92.zip
Unit Test to check the shell script and Dockerfile lint. Travis.ci intergrated.
Refer: https://github.com/projectatomic/dockerfile_lint Signed-off-by: Mohamed Ashiq Liyazudeen <mliyazud@redhat.com>
Diffstat (limited to 'tests/common')
-rwxr-xr-xtests/common/subunit.sh113
1 files changed, 113 insertions, 0 deletions
diff --git a/tests/common/subunit.sh b/tests/common/subunit.sh
new file mode 100755
index 0000000..71aba94
--- /dev/null
+++ b/tests/common/subunit.sh
@@ -0,0 +1,113 @@
+#
+# subunit.sh: shell functions to report test status via the subunit protocol.
+# Copyright (C) 2006 Robert Collins <robertc@robertcollins.net>
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+#
+
+timestamp() {
+ # mark the start time. With Gnu date, you get nanoseconds from %N
+ # (here truncated to microseconds with %6N), but not on BSDs,
+ # Solaris, etc, which will apparently leave either %N or N at the end.
+ date -u +'time: %Y-%m-%d %H:%M:%S.%6NZ' | sed 's/\..*NZ$/.000000Z/'
+}
+
+subunit_start_test () {
+ # emit the current protocol start-marker for test $1
+ timestamp
+ echo "test: $1"
+}
+
+
+subunit_pass_test () {
+ # emit the current protocol test passed marker for test $1
+ timestamp
+ echo "success: $1"
+}
+
+# This is just a hack as we have some broken scripts
+# which use "exit $failed", without initializing failed.
+failed=0
+
+subunit_fail_test () {
+ # emit the current protocol fail-marker for test $1, and emit stdin as
+ # the error text.
+ # we use stdin because the failure message can be arbitrarily long, and this
+ # makes it convenient to write in scripts (using <<END syntax.
+ timestamp
+ echo "failure: $1 ["
+ cat -
+ echo "]"
+}
+
+
+subunit_error_test () {
+ # emit the current protocol error-marker for test $1, and emit stdin as
+ # the error text.
+ # we use stdin because the failure message can be arbitrarily long, and this
+ # makes it convenient to write in scripts (using <<END syntax.
+ timestamp
+ echo "error: $1 ["
+ cat -
+ echo "]"
+}
+
+subunit_skip_test () {
+ # emit the current protocol skip-marker for test $1, and emit stdin as
+ # the error text.
+ # we use stdin because the failure message can be arbitrarily long, and this
+ # makes it convenient to write in scripts (using <<END syntax.
+ echo "skip: $1 ["
+ cat -
+ echo "]"
+}
+
+testit () {
+ name="$1"
+ shift
+ cmdline="$*"
+ subunit_start_test "$name"
+ output=`$cmdline 2>&1`
+ status=$?
+ if [ x$status = x0 ]; then
+ subunit_pass_test "$name"
+ else
+ echo "$output" | subunit_fail_test "$name"
+ fi
+ return $status
+}
+
+testit_expect_failure () {
+ name="$1"
+ shift
+ cmdline="$*"
+ subunit_start_test "$name"
+ output=`$cmdline 2>&1`
+ status=$?
+ if [ x$status = x0 ]; then
+ echo "$output" | subunit_fail_test "$name"
+ else
+ subunit_pass_test "$name"
+ fi
+ return $status
+}
+
+testok () {
+ name=`basename $1`
+ failed=$2
+
+ exit $failed
+}